Osmocom logging framework

## Files

file | logging.h
file | logging.c
file | logging_gsmtap.c
file | logging_syslog.c

## Data Structures

struct | log_category
| Configuration of single log category / sub-system. More...
struct | log_info_cat
| Information regarding one logging category. More...
struct | log_context
| Log context information, passed to filter. More...
struct | log_info
| Logging configuration, passed to log_init. More...
struct | log_target
| structure representing a logging target More...

## Macros

#define | LOG_MAX_CTX 8
| Maximum number of logging contexts. More...
#define | LOG_MAX_FILTERS 8
| Maximum number of logging filters. More...
#define | DEBUG
#define | DEBUGP(ss, fmt, args...) LOGP(ss, LOGL_DEBUG, fmt, ##args)
| Log a debug message through the Osmocom logging framework. More...
#define | DEBUGPC(ss, fmt, args...) LOGPC(ss, LOGL_DEBUG, fmt, ##args)
#define | LOGP(ss, level, fmt, args...) LOGPSRC(ss, level, NULL, 0, fmt, ## args)
| Log a new message through the Osmocom logging framework. More...
#define | LOGPC(ss, level, fmt, args...)
| Continue a log message through the Osmocom logging framework. More...
#define | LOGPSRC(ss, level, caller_file, caller_line, fmt, args...) LOGPSRCC(ss, level, caller_file, caller_line, 0, fmt, ##args)
| Log through the Osmocom logging framework with explicit source. More...
#define | LOGPSRCC(ss, level, caller_file, caller_line, cont, fmt, args...)
| Log through the Osmocom logging framework with explicit source. More...
#define | LOGL_DEBUG 1
| different log levels More...
#define | LOGL_INFO 3
| general information More...
#define | LOGL_NOTICE 5
| abnormal/unexpected condition More...
#define | LOGL_ERROR 7
| error condition, requires user action More...
#define | LOGL_FATAL 8
| fatal, program aborted More...
#define | DLGLOBAL -1
| global logging More...
#define | DLLAPD -2
| LAPD implementation. More...
#define | DLINP -3
| (A-bis) Input sub-system More...
#define | DLMUX -4
| Osmocom Multiplex (Osmux) More...
#define | DLMI -5
| ISDN-layer below input sub-system. More...
#define | DLMIB -6
| ISDN layer B-channel. More...
#define | DLSMS -7
| SMS sub-system. More...
#define | DLCTRL -8
| Control Interface. More...
#define | DLGTP -9
| GTP (GPRS Tunneling Protocol. More...
#define | DLSTATS -10
| Statistics. More...
#define | DLGSUP -11
| Generic Subscriber Update Protocol. More...
#define | DLOAP -12
| Osmocom Authentication Protocol. More...
#define | DLSS7 -13
| Osmocom SS7. More...
#define | DLSCCP -14
| Osmocom SCCP. More...
#define | DLSUA -15
| Osmocom SUA. More...
#define | DLM3UA -16
| Osmocom M3UA. More...
#define | DLMGCP -17
| Osmocom MGCP. More...
#define | DLJIBUF -18
| Osmocom Jitter Buffer. More...
#define | OSMO_NUM_DLIB 18
| Number of logging sub-systems in libraries. More...
#define | LOG_FILTER_ALL (1<<LOG_FLT_ALL)
| Compatibility with older libosmocore versions. More...
#define | GPRS_CTX_NSVC LOG_CTX_GB_NSVC
| Compatibility with older libosmocore versions. More...
#define | GPRS_CTX_BVC LOG_CTX_GB_BVC
| Compatibility with older libosmocore versions. More...
#define | LOGLEVEL_DEFS 6 /* Number of loglevels.*/
#define | INT2IDX(x) (-1*(x)-1)
#define | GSMTAP_LOG_MAX_SIZE 4096

## Typedefs

typedef int | log_filter(const struct log_context *ctx, struct log_target *target)
| Log filter function. More...
typedef void | log_print_filters(struct vty *vty, const struct log_info *info, const struct log_target *tgt)
typedef void | log_save_filters(struct vty *vty, const struct log_info *info, const struct log_target *tgt)

## Enumerations

enum | log_ctx_index { LOG_CTX_GB_NSVC, LOG_CTX_GB_BVC, LOG_CTX_BSC_SUBSCR, LOG_CTX_VLR_SUBSCR, _LOG_CTX_COUNT }
| Indexes to indicate the object currently acted upon. More...
enum | log_filter_index { LOG_FLT_ALL, LOG_FLT_GB_NSVC, LOG_FLT_GB_BVC, LOG_FLT_BSC_SUBSCR, LOG_FLT_VLR_SUBSCR, _LOG_FLT_COUNT }
| Indexes to indicate objects that should be logged. More...
enum | log_target_type { LOG_TGT_TYPE_VTY, LOG_TGT_TYPE_SYSLOG, LOG_TGT_TYPE_FILE, LOG_TGT_TYPE_STDERR, LOG_TGT_TYPE_STRRB, LOG_TGT_TYPE_GSMTAP }
| Type of logging target. More...
enum | log_filename_type { LOG_FILENAME_NONE, LOG_FILENAME_PATH, LOG_FILENAME_BASENAME }
| Whether/how to log the source filename (and line number). More...

## Functions

void | osmo_vlogp (int subsys, int level, const char *file, int line, int cont, const char *format, va_list ap)
| vararg version of logging function More...
void | logp (int subsys, const char *file, int line, int cont, const char *format,...)
| logging function used by DEBUGP() macro More...
void | logp2 (int subsys, unsigned int level, const char *file, int line, int cont, const char *format,...)
| logging function used by LOGP() macro More...
void int | log_init (const struct log_info *inf, void *ctx)
| Initialize the Osmocom logging core. More...
void | log_fini (void)
int | log_check_level (int subsys, unsigned int level)
| Check whether a log entry will be generated. More...
void | log_reset_context (void)
| Reset (clear) the logging context. More...
int | log_set_context (uint8_t ctx_nr, void *value)
| Set the logging context. More...
void | log_set_all_filter (struct log_target *target, int all)
| Enable the LOG_FLT_ALL log filter. More...
void | log_set_use_color (struct log_target *target, int use_color)
| Enable or disable the use of colored output. More...
void | log_set_print_extended_timestamp (struct log_target *target, int print_timestamp)
| Enable or disable printing of extended timestamps while logging. More...
void | log_set_print_timestamp (struct log_target *target, int print_timestamp)
| Enable or disable printing of timestamps while logging. More...
void | log_set_print_filename (struct log_target *target, int print_filename)
| Use log_set_print_filename2() instead. More...
void | log_set_print_filename2 (struct log_target *target, enum log_filename_type lft)
| Enable or disable printing of the filename while logging. More...
void | log_set_print_category (struct log_target *target, int print_category)
| Enable or disable printing of the category name. More...
void | log_set_print_category_hex (struct log_target *target, int print_category_hex)
| Enable or disable printing of the category number in hex ('<000b>'). More...
void | log_set_print_level (struct log_target *target, int print_level)
| Enable or disable printing of the log level name. More...
void | log_set_log_level (struct log_target *target, int log_level)
| Set the global log level for a given log target. More...
void | log_parse_category_mask (struct log_target *target, const char *_mask)
| parse the log category mask More...
const char * | log_category_name (int subsys)
int | log_parse_level (const char *lvl)
| Parse a human-readable log level into a numeric value. More...
const char * | log_level_str (unsigned int lvl)
| convert a numeric log level into human-readable string More...
int | log_parse_category (const char *category)
| parse a human-readable log category into numeric form More...
void | log_set_category_filter (struct log_target *target, int category, int enable, int level)
| Set a category filter on a given log target. More...
struct log_target * | log_target_create (void)
| Create a new log target skeleton. More...
void | log_target_destroy (struct log_target *target)
| Unregister, close and delete a log target. More...
struct log_target * | log_target_create_stderr (void)
| Create the STDERR log target. More...
struct log_target * | log_target_create_file (const char *fname)
| Create a new file-based log target. More...
struct log_target * | log_target_create_syslog (const char *ident, int option, int facility)
| Create a new logging target for syslog logging. More...
struct log_target * | log_target_create_gsmtap (const char *host, uint16_t port, const char *ident, bool ofd_wq_mode, bool add_sink)
| Create a new logging target for GSMTAP logging. More...
int | log_target_file_reopen (struct log_target *target)
| close and re-open a log file (for log file rotation) More...
int | log_targets_reopen (void)
| close and re-open all log files (for log file rotation) More...
void | log_add_target (struct log_target *target)
| Register a new log target with the logging core. More...
void | log_del_target (struct log_target *target)
| Unregister a log target from the logging core. More...
const char * | log_vty_command_string ()
| Generates the logging command string for VTY. More...
const char * | log_vty_command_description ()
| Generates the logging command description for VTY. More...
struct log_target * | log_target_find (int type, const char *fname)
| Find a registered log target. More...
| osmo_static_assert (_LOG_CTX_COUNT<=ARRAY_SIZE(((struct log_context *) NULL) ->ctx), enum_logging_ctx_items_fit_in_struct_log_context)
| osmo_static_assert (_LOG_FLT_COUNT<=ARRAY_SIZE(((struct log_target *) NULL) ->filter_data), enum_logging_filters_fit_in_log_target_filter_data)
| osmo_static_assert (_LOG_FLT_COUNT<=8 *sizeof(((struct log_target *) NULL) ->filter_map), enum_logging_filters_fit_in_log_target_filter_map)
| LLIST_HEAD (osmo_log_target_list)
static void | assert_loginfo (const char *src)
static int | subsys_lib2index (int subsys)
static const char * | color (int subsys)
static const char * | level_color (int level)
static const char * | const_basename (const char *path)
static void | _output (struct log_target *target, unsigned int subsys, unsigned int level, const char *file, int line, int cont, const char *format, va_list ap)
static int | map_subsys (int subsys)
static bool | should_log_to_target (struct log_target *tar, int subsys, int level)
static void | _file_output (struct log_target *target, unsigned int level, const char *log)
static void | _gsmtap_raw_output (struct log_target *target, int subsys, unsigned int level, const char *file, int line, int cont, const char *format, va_list ap)
static int | logp2syslog_level (unsigned int level)
static void | _syslog_output (struct log_target *target, unsigned int level, const char *log)

## Variables

struct llist_head | osmo_log_target_list
struct log_info * | osmo_log_info
static struct log_context | log_context
static void * | tall_log_ctx = NULL
static const struct value_string | loglevel_strs [LOGLEVEL_DEFS+1]
static const struct log_info_cat | internal_cat [OSMO_NUM_DLIB]
static const char * | loglevel_descriptions [LOGLEVEL_DEFS+1]
| descriptive string for each log level More...
static const struct value_string | level_colors []

## Detailed Description

libosmocore Logging sub-system

## Macro Definition Documentation

## DEBUG

#define DEBUG

## DEBUGP

#define DEBUGP | ( |  | ss,
|  |  | fmt,
|  |  | args...
| ) |  | LOGP(ss, LOGL_DEBUG, fmt, ##args)

Log a debug message through the Osmocom logging framework.

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | fmt | format string
  [in] | args | variable argument list

## DEBUGPC

#define DEBUGPC | ( |  | ss,
|  |  | fmt,
|  |  | args...
| ) |  | LOGPC(ss, LOGL_DEBUG, fmt, ##args)

## DLCTRL

#define DLCTRL -8

Control Interface.

## DLGLOBAL

#define DLGLOBAL -1

global logging

## DLGSUP

#define DLGSUP -11

Generic Subscriber Update Protocol.

## DLGTP

#define DLGTP -9

GTP (GPRS Tunneling Protocol.

## DLINP

#define DLINP -3

(A-bis) Input sub-system

## DLJIBUF

#define DLJIBUF -18

Osmocom Jitter Buffer.

## DLLAPD

#define DLLAPD -2

LAPD implementation.

## DLM3UA

#define DLM3UA -16

Osmocom M3UA.

## DLMGCP

#define DLMGCP -17

Osmocom MGCP.

## DLMI

#define DLMI -5

ISDN-layer below input sub-system.

## DLMIB

#define DLMIB -6

ISDN layer B-channel.

## DLMUX

#define DLMUX -4

Osmocom Multiplex (Osmux)

## DLOAP

#define DLOAP -12

Osmocom Authentication Protocol.

## DLSCCP

#define DLSCCP -14

Osmocom SCCP.

## DLSMS

#define DLSMS -7

SMS sub-system.

## DLSS7

#define DLSS7 -13

Osmocom SS7.

## DLSTATS

#define DLSTATS -10

Statistics.

## DLSUA

#define DLSUA -15

Osmocom SUA.

## GPRS_CTX_BVC

#define GPRS_CTX_BVC LOG_CTX_GB_BVC

Compatibility with older libosmocore versions.

## GPRS_CTX_NSVC

#define GPRS_CTX_NSVC LOG_CTX_GB_NSVC

Compatibility with older libosmocore versions.

## GSMTAP_LOG_MAX_SIZE

#define GSMTAP_LOG_MAX_SIZE 4096

## INT2IDX

#define INT2IDX | ( |  | x | ) | (-1*(x)-1)

## LOG_FILTER_ALL

#define LOG_FILTER_ALL (1<<LOG_FLT_ALL)

Compatibility with older libosmocore versions.

## LOG_MAX_CTX

#define LOG_MAX_CTX 8

Maximum number of logging contexts.

## LOG_MAX_FILTERS

#define LOG_MAX_FILTERS 8

Maximum number of logging filters.

## LOGL_DEBUG

#define LOGL_DEBUG 1

different log levels

debugging information

## LOGL_ERROR

#define LOGL_ERROR 7

error condition, requires user action

## LOGL_FATAL

#define LOGL_FATAL 8

fatal, program aborted

## LOGL_INFO

#define LOGL_INFO 3

general information

## LOGL_NOTICE

#define LOGL_NOTICE 5

abnormal/unexpected condition

## LOGLEVEL_DEFS

#define LOGLEVEL_DEFS 6 /* Number of loglevels.*/

## LOGP

#define LOGP | ( |  | ss,
|  |  | level,
|  |  | fmt,
|  |  | args...
| ) |  | LOGPSRC(ss, level, NULL, 0, fmt, ## args)

Log a new message through the Osmocom logging framework.

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | level | logging level (e.g. LOGL_NOTICE)
  [in] | fmt | format string
  [in] | args | variable argument list

## LOGPC

#define LOGPC | ( |  | ss,
|  |  | level,
|  |  | fmt,
|  |  | args...
| ) |  |

Value:
do { \
if (log_check_level(ss, level)) \
logp2(ss, level, __BASE_FILE__, __LINE__, 1, fmt, ##args); \
} while(0)

Continue a log message through the Osmocom logging framework.

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | level | logging level (e.g. LOGL_NOTICE)
  [in] | fmt | format string
  [in] | args | variable argument list

## LOGPSRC

#define LOGPSRC | ( |  | ss,
|  |  | level,
|  |  | caller_file,
|  |  | caller_line,
|  |  | fmt,
|  |  | args...
| ) |  | LOGPSRCC(ss, level, caller_file, caller_line, 0, fmt, ##args)

Log through the Osmocom logging framework with explicit source.

If caller_file is passed as NULL, BASE_FILE and LINE are used instead of caller_file and caller_line (so that this macro here defines both cases in the same place, and to catch cases where callers fail to pass a non-null filename string).

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | level | logging level (e.g. LOGL_NOTICE)
  [in] | caller_file | caller's source file string (e.g. BASE_FILE)
  [in] | caller_line | caller's source line nr (e.g. LINE)
  [in] | fmt | format string
  [in] | args | variable argument list

## LOGPSRCC

#define LOGPSRCC | ( |  | ss,
|  |  | level,
|  |  | caller_file,
|  |  | caller_line,
|  |  | cont,
|  |  | fmt,
|  |  | args...
| ) |  |

Value:
do { \
if (log_check_level(ss, level)) {\
if (caller_file) \
logp2(ss, level, caller_file, caller_line, cont, fmt, ##args); \
else \
logp2(ss, level, __BASE_FILE__, __LINE__, cont, fmt, ##args); \
}\
} while(0)

Log through the Osmocom logging framework with explicit source.

If caller_file is passed as NULL, BASE_FILE and LINE are used instead of caller_file and caller_line (so that this macro here defines both cases in the same place, and to catch cases where callers fail to pass a non-null filename string).

Parameters

  [in] | ss | logging subsystem (e.g. DLGLOBAL)
  [in] | level | logging level (e.g. LOGL_NOTICE)
  [in] | caller_file | caller's source file string (e.g. BASE_FILE)
  [in] | caller_line | caller's source line nr (e.g. LINE)
  [in] | cont | continuation (1) or new line (0)
  [in] | fmt | format string
  [in] | args | variable argument list

## OSMO_NUM_DLIB

#define OSMO_NUM_DLIB 18

Number of logging sub-systems in libraries.

## Typedef Documentation

## log_filter

typedef int log_filter(const struct log_context *ctx, struct log_target *target)

Log filter function.

## log_print_filters

typedef void log_print_filters(struct vty *vty, const struct log_info *info, const struct log_target *tgt)

## log_save_filters

typedef void log_save_filters(struct vty *vty, const struct log_info *info, const struct log_target *tgt)

## Enumeration Type Documentation

## log_ctx_index

enum log_ctx_index

Indexes to indicate the object currently acted upon.

Array indexes for the global log_context array.

Enumerator
LOG_CTX_GB_NSVC |
LOG_CTX_GB_BVC |
LOG_CTX_BSC_SUBSCR |
LOG_CTX_VLR_SUBSCR |
_LOG_CTX_COUNT |

## log_filename_type

enum log_filename_type

Whether/how to log the source filename (and line number).

Enumerator
LOG_FILENAME_NONE |
LOG_FILENAME_PATH |
LOG_FILENAME_BASENAME |

## log_filter_index

enum log_filter_index

Indexes to indicate objects that should be logged.

Array indexes to log_target->filter_data and bit indexes for log_target->filter_map.

Enumerator
LOG_FLT_ALL |
LOG_FLT_GB_NSVC |
LOG_FLT_GB_BVC |
LOG_FLT_BSC_SUBSCR |
LOG_FLT_VLR_SUBSCR |
_LOG_FLT_COUNT |

## log_target_type

enum log_target_type

Type of logging target.

Enumerator
LOG_TGT_TYPE_VTY | VTY logging.
LOG_TGT_TYPE_SYSLOG | syslog based logging
LOG_TGT_TYPE_FILE | text file logging
LOG_TGT_TYPE_STDERR | stderr logging
LOG_TGT_TYPE_STRRB | osmo_strrb-backed logging
LOG_TGT_TYPE_GSMTAP | GSMTAP network logging.

## Function Documentation

## _file_output()

static void _file_output | ( | struct log_target * | target,
|  | unsigned int | level,
|  | const char * | log
| ) |  |

static

References log_target::tgt_file.

Referenced by log_target_create_file(), log_target_create_stderr(), and log_target_destroy().

## _gsmtap_raw_output()

static void _gsmtap_raw_output | ( | struct log_target * | target,
|  | int | subsys,
|  | unsigned int | level,
|  | const char * | file,
|  | int | line,
|  | int | cont,
|  | const char * | format,
|  | va_list | ap
| ) |  |

static

References GSMTAP_LOG_MAX_SIZE, gsmtap_sendmsg(), GSMTAP_TYPE_OSMOCORE_LOG, GSMTAP_VERSION, gsmtap_hdr::hdr_len, level, gsmtap_osmocore_log_hdr::level, gsmtap_osmocore_log_hdr::line_nr, log_category_name(), msgb_alloc(), msgb_free(), msgb_put(), msgb_tailroom(), gsmtap_osmocore_log_hdr::name, osmo_gettimeofday(), osmo_htonl, OSMO_STRLCPY_ARRAY, gsmtap_osmocore_log_hdr::proc_name, gsmtap_osmocore_log_hdr::sec, gsmtap_osmocore_log_hdr::src_file, subsys, gsmtap_osmocore_log_hdr::subsys, msgb::tail, log_target::tgt_gsmtap, gsmtap_osmocore_log_hdr::ts, gsmtap_hdr::type, gsmtap_osmocore_log_hdr::usec, and gsmtap_hdr::version.

Referenced by log_target_create_gsmtap().

## _output()

static void _output | ( | struct log_target * | target,
|  | unsigned int | subsys,
|  | unsigned int | level,
|  | const char * | file,
|  | int | line,
|  | int | cont,
|  | const char * | format,
|  | va_list | ap
| ) |  |

static

References color(), const_basename(), level, level_color(), log_category_name(), LOG_FILENAME_BASENAME, LOG_FILENAME_NONE, LOG_FILENAME_PATH, log_level_str(), osmo_gettimeofday(), OSMO_SNPRINTF_RET, log_target::output, log_target::print_category, log_target::print_category_hex, log_target::print_ext_timestamp, log_target::print_filename2, log_target::print_level, log_target::print_timestamp, subsys, and log_target::use_color.

Referenced by osmo_vlogp().

## _syslog_output()

static void _syslog_output | ( | struct log_target * | target,
|  | unsigned int | level,
|  | const char * | log
| ) |  |

static

References level, and logp2syslog_level().

Referenced by log_target_create_syslog().

## assert_loginfo()

static void assert_loginfo | ( | const char * | src | ) |

static

References OSMO_ASSERT, and osmo_log_info.

Referenced by log_check_level(), log_parse_category(), log_parse_category_mask(), log_target_create(), log_vty_command_description(), and log_vty_command_string().

## color()

static const char* color | ( | int | subsys | ) |

static

References log_info::cat, log_info_cat::color, osmo_log_info, and subsys.

Referenced by _output(), rb_erase(), and rb_set_color().

## const_basename()

static const char* const_basename | ( | const char * | path | ) |

static

Referenced by _output().

## level_color()

static const char* level_color | ( | int | level | ) |

static

References get_value_string(), get_value_string_or_null(), level, level_colors, and LOGL_FATAL.

Referenced by _output().

## LLIST_HEAD()

LLIST_HEAD | ( | osmo_log_target_list |  | ) |

## log_add_target()

void log_add_target | ( | struct log_target * | target | ) |

Register a new log target with the logging core.

Parameters

  [in] | target | Log target to be registered

References log_target::entry, llist_add_tail(), and osmo_log_target_list.

Referenced by osmo_init_logging2().

## log_category_name()

const char * log_category_name | ( | int | subsys | ) |

References log_info::cat, log_info_cat::name, osmo_log_info, and subsys.

Referenced by _gsmtap_raw_output(), and _output().

## log_check_level()

int log_check_level | ( | int | subsys,
|  | unsigned int | level
| ) |  |

Check whether a log entry will be generated.

Returns
  != 0 if a log entry might get generated by at least one target

References assert_loginfo(), log_target::entry, level, llist_for_each_entry, map_subsys(), osmo_log_target_list, should_log_to_target(), and subsys.

## log_del_target()

void log_del_target | ( | struct log_target * | target | ) |

Unregister a log target from the logging core.

Parameters

  [in] | target | Log target to be unregistered

References log_target::entry, and llist_del().

Referenced by log_target_destroy().

## log_fini()

void log_fini | ( | void |  | ) |

References log_target::entry, llist_for_each_entry_safe, log_target_destroy(), osmo_log_info, osmo_log_target_list, and tall_log_ctx.

## log_init()

int log_init | ( | const struct log_info * | inf,
|  | void * | ctx
| ) |  |

Initialize the Osmocom logging core.

Parameters

  [in] | inf | Information regarding logging categories
  [in] | ctx | talloc context for logging allocations

Returns
  0 in case of success, negative in case of error

References ARRAY_SIZE, log_info::cat, log_info::filter_fn, internal_cat, log_info::num_cat, log_info::num_cat_user, osmo_log_info, and tall_log_ctx.

Referenced by osmo_init_logging2().

## log_level_str()

const char * log_level_str | ( | unsigned int | lvl | ) |

convert a numeric log level into human-readable string

Parameters

  lvl[in] | numeric log level

Returns
  zero-terminated string (log level name)

References get_value_string(), and loglevel_strs.

Referenced by _output().

## log_parse_category()

int log_parse_category | ( | const char * | category | ) |

parse a human-readable log category into numeric form

Parameters

  [in] | category | human-readable log category name

Returns
  numeric category value, or -EINVAL otherwise

References assert_loginfo(), log_info::cat, log_info_cat::name, log_info::num_cat, and osmo_log_info.

## log_parse_category_mask()

void log_parse_category_mask | ( | struct log_target * | target,
|  | const char * | _mask
| ) |  |

parse the log category mask

Parameters

  [in] | target | log target to be configured
  [in] | _mask | log category mask string

The format can be this: category1:category2:category3 or category1,2:category2,3:...

References assert_loginfo(), log_info::cat, log_target::categories, log_category::enabled, level, log_category::loglevel, log_info_cat::name, log_info::num_cat, OSMO_ASSERT, and osmo_log_info.

## log_parse_level()

int log_parse_level | ( | const char * | lvl | ) |

Parse a human-readable log level into a numeric value.

Parameters

  lvl[in] | zero-terminated string containing log level name

Returns
  numeric log level

References get_string_value(), and loglevel_strs.

## log_reset_context()

void log_reset_context | ( | void |  | ) |

Reset (clear) the logging context.

## log_set_all_filter()

void log_set_all_filter | ( | struct log_target * | target,
|  | int | all
| ) |  |

Enable the LOG_FLT_ALL log filter.

Parameters

  [in] | target | Log target to be affected
  [in] | all | enable (1) or disable (0) the ALL filter

When the LOG_FLT_ALL filter is enabled, all log messages will be printed. It acts as a wildcard. Setting it to 1 means there is no filtering.

References log_target::filter_map, and LOG_FLT_ALL.

Referenced by osmo_init_logging2().

## log_set_category_filter()

void log_set_category_filter | ( | struct log_target * | target,
|  | int | category,
|  | int | enable,
|  | int | level
| ) |  |

Set a category filter on a given log target.

Parameters

  [in] | target | Log target to be affected
  [in] | category | Log category to be affected
  [in] | enable | whether to enable or disable the filter
  [in] | level | Log level of the filter

References log_target::categories, log_category::enabled, level, log_category::loglevel, and map_subsys().

## log_set_context()

int log_set_context | ( | uint8_t | ctx_nr,
|  | void * | value
| ) |  |

Set the logging context.

Parameters

  [in] | ctx_nr | logging context number
  [in] | value | value to which the context is to be set

Returns
  0 in case of success; negative otherwise

A logging context is something like the subscriber identity to which the currently processed message relates, or the BTS through which it was received. As soon as this data is known, it can be set using this function. The main use of context information is for logging filters.

References log_context::ctx, and LOG_MAX_CTX.

## log_set_log_level()

void log_set_log_level | ( | struct log_target * | target,
|  | int | log_level
| ) |  |

Set the global log level for a given log target.

Parameters

  [in] | target | Log target to be affected
  [in] | log_level | New global log level

References log_target::loglevel.

## log_set_print_category()

void log_set_print_category | ( | struct log_target * | target,
|  | int | print_category
| ) |  |

Enable or disable printing of the category name.

Parameters

  [in] | target | Log target to be affected
  [in] | print_catname | Enable (1) or disable (0) filenames

Print the category/subsys name in front of every log message.

References log_target::print_category.

## log_set_print_category_hex()

void log_set_print_category_hex | ( | struct log_target * | target,
|  | int | print_category_hex
| ) |  |

Enable or disable printing of the category number in hex ('<000b>').

Parameters

  [in] | target | Log target to be affected.
  [in] | print_category_hex | Enable (1) or disable (0) hex category.

References log_target::print_category_hex.

Referenced by log_set_print_filename().

## log_set_print_extended_timestamp()

void log_set_print_extended_timestamp | ( | struct log_target * | target,
|  | int | print_timestamp
| ) |  |

Enable or disable printing of extended timestamps while logging.

Parameters

  [in] | target | Log target to be affected
  [in] | print_timestamp | Enable (1) or disable (0) timestamps

When both timestamp and extended timestamp is enabled then only the extended timestamp will be used. The format of the timestamp is YYYYMMDDhhmmssnnn.

References log_target::print_ext_timestamp, and log_target::print_timestamp.

## log_set_print_filename()

void log_set_print_filename | ( | struct log_target * | target,
|  | int | print_filename
| ) |  |

Use log_set_print_filename2() instead.

Call log_set_print_filename2() with LOG_FILENAME_PATH or LOG_FILENAME_NONE, as well as call log_set_print_category_hex() with the argument passed to this function. This is to mirror legacy behavior, which combined the category in hex with the filename. For example, if the category-hex output were no longer affected by log_set_print_filename(), many unit tests (in libosmocore as well as dependent projects) would fail since they expect the category to disappear along with the filename.

Parameters

  [in] | target | Log target to be affected
  [in] | print_filename | Enable (1) or disable (0) filenames

References LOG_FILENAME_NONE, LOG_FILENAME_PATH, log_set_print_category_hex(), log_set_print_filename2(), and log_target::print_filename.

## log_set_print_filename2()

void log_set_print_filename2 | ( | struct log_target * | target,
|  | enum log_filename_type | lft
| ) |  |

Enable or disable printing of the filename while logging.

Parameters

  [in] | target | Log target to be affected.
  [in] | print_filename | An LOG_FILENAME_* enum value. LOG_FILENAME_NONE omits the source file and line information from logs. LOG_FILENAME_PATH prints the entire source file path as passed to LOGP macros.

References log_target::print_filename2.

Referenced by log_set_print_filename().

## log_set_print_level()

void log_set_print_level | ( | struct log_target * | target,
|  | int | print_level
| ) |  |

Enable or disable printing of the log level name.

Parameters

  [in] | target | Log target to be affected
  [in] | print_catname | Enable (1) or disable (0) filenames

Print the log level name in front of every log message.

References log_target::print_level.

## log_set_print_timestamp()

void log_set_print_timestamp | ( | struct log_target * | target,
|  | int | print_timestamp
| ) |  |

Enable or disable printing of timestamps while logging.

Parameters

  [in] | target | Log target to be affected
  [in] | print_timestamp | Enable (1) or disable (0) timestamps

References log_target::print_timestamp.

## log_set_use_color()

void log_set_use_color | ( | struct log_target * | target,
|  | int | use_color
| ) |  |

Enable or disable the use of colored output.

Parameters

  [in] | target | Log target to be affected
  [in] | use_color | Use color (1) or don't use color (0)

References log_target::use_color.

## log_target_create()

struct log_target * log_target_create | ( | void |  | ) |

Create a new log target skeleton.

Returns
  dynamically-allocated log target This funcition allocates a log_target and initializes it with some default values. The newly created target is not registered yet.

References assert_loginfo(), log_info::cat, log_target::categories, log_category::enabled, log_info_cat::enabled, log_target::entry, INIT_LLIST_HEAD, LOG_FILENAME_PATH, log_category::loglevel, log_info_cat::loglevel, log_target::loglevel, log_info::num_cat, osmo_log_info, log_target::print_category_hex, log_target::print_filename2, log_target::print_timestamp, tall_log_ctx, and log_target::use_color.

Referenced by log_target_create_file(), log_target_create_gsmtap(), log_target_create_rb(), log_target_create_stderr(), and log_target_create_syslog().

## log_target_create_file()

struct log_target * log_target_create_file | ( | const char * | fname | ) |

Create a new file-based log target.

Parameters

  [in] | fname | File name of the new log file

Returns
  Log target in case of success, NULL otherwise

References _file_output(), log_target::fname, log_target_create(), LOG_TGT_TYPE_FILE, log_target::output, log_target::tgt_file, and log_target::type.

## log_target_create_gsmtap()

struct log_target * log_target_create_gsmtap | ( | const char * | host,
|  | uint16_t | port,
|  | const char * | ident,
|  | bool | ofd_wq_mode,
|  | bool | add_sink
| ) |  |

Create a new logging target for GSMTAP logging.

Parameters

  [in] | ident | string identifier

Returns
  Log target in case of success, NULL in case of error

References _gsmtap_raw_output(), gsmtap_source_add_sink(), gsmtap_source_init(), log_target_create(), log_target_destroy(), LOG_TGT_TYPE_GSMTAP, gsmtap_inst::ofd_wq_mode, log_target::raw_output, log_target::tgt_gsmtap, and log_target::type.

## log_target_create_stderr()

struct log_target * log_target_create_stderr | ( | void |  | ) |

Create the STDERR log target.

Returns
  dynamically-allocated log_target for STDERR

References _file_output(), log_target_create(), LOG_TGT_TYPE_STDERR, log_target::output, log_target::tgt_file, and log_target::type.

Referenced by osmo_init_logging2().

## log_target_create_syslog()

struct log_target * log_target_create_syslog | ( | const char * | ident,
|  | int | option,
|  | int | facility
| ) |  |

Create a new logging target for syslog logging.

Parameters

  [in] | ident | syslog string identifier
  [in] | option | syslog options
  [in] | facility | syslog facility

Returns
  Log target in case of success, NULL in case of error

References _syslog_output(), log_target::facility, log_target::ident, log_target_create(), LOG_TGT_TYPE_SYSLOG, log_target::output, log_target::tgt_syslog, and log_target::type.

## log_target_destroy()

void log_target_destroy | ( | struct log_target * | target | ) |

Unregister, close and delete a log target.

Parameters

  target[in] | log target to unregister, close and delete

References _file_output(), log_del_target(), log_target::output, and log_target::tgt_file.

Referenced by log_fini(), log_target_create_gsmtap(), and log_target_create_rb().

## log_target_file_reopen()

int log_target_file_reopen | ( | struct log_target * | target | ) |

close and re-open a log file (for log file rotation)

Parameters

  [in] | target | log target to re-open

Returns
  0 in case of success; negative otherwise

References log_target::tgt_file.

Referenced by log_targets_reopen().

## log_target_find()

struct log_target * log_target_find | ( | int | type,
|  | const char * | fname
| ) |  |

Find a registered log target.

Parameters

  [in] | type | Log target type
  [in] | fname | File name

Returns
  Log target (if found), NULL otherwise

References log_target::entry, log_target::fname, llist_for_each_entry, LOG_TGT_TYPE_FILE, LOG_TGT_TYPE_GSMTAP, osmo_log_target_list, log_target::tgt_file, log_target::tgt_gsmtap, type, and log_target::type.

## log_targets_reopen()

int log_targets_reopen | ( | void |  | ) |

close and re-open all log files (for log file rotation)

Returns
  0 in case of success; negative otherwise

References log_target::entry, llist_for_each_entry, log_target_file_reopen(), LOG_TGT_TYPE_FILE, osmo_log_target_list, and log_target::type.

Referenced by sighup_hdlr().

## log_vty_command_description()

const char * log_vty_command_description | ( |  | ) |

Generates the logging command description for VTY.

Parameters

  [in] | unused_info | Deprecated parameter, no longer used!

Returns
  logging command description for use by VTY command node

References assert_loginfo(), log_info::cat, log_info_cat::description, LOGLEVEL_DEFS, loglevel_descriptions, log_info_cat::name, log_info::num_cat, osmo_log_info, OSMO_SNPRINTF_RET, and tall_log_ctx.

## log_vty_command_string()

const char * log_vty_command_string | ( |  | ) |

Generates the logging command string for VTY.

Parameters

  [in] | unused_info | Deprecated parameter, no longer used!

Returns
  vty command string for use by VTY command node

References assert_loginfo(), log_info::cat, LOGLEVEL_DEFS, loglevel_strs, name, log_info_cat::name, log_info::num_cat, osmo_log_info, OSMO_SNPRINTF_RET, and tall_log_ctx.

## logp()

void logp | ( | int | subsys,
|  | const char * | file,
|  | int | line,
|  | int | cont,
|  | const char * | format,
|  |  | ...
| ) |  |

logging function used by DEBUGP() macro

Parameters

  [in] | subsys | Logging sub-system
  [in] | file | name of source code file
  [in] | cont | continuation (1) or new line (0)
  [in] | format | format string

References LOGL_DEBUG, osmo_vlogp(), and subsys.

## logp2()

void logp2 | ( | int | subsys,
|  | unsigned int | level,
|  | const char * | file,
|  | int | line,
|  | int | cont,
|  | const char * | format,
|  |  | ...
| ) |  |

logging function used by LOGP() macro

Parameters

  [in] | subsys | Logging sub-system
  [in] | level | Log level
  [in] | file | name of source code file
  [in] | cont | continuation (1) or new line (0)
  [in] | format | format string

References level, osmo_vlogp(), and subsys.

## logp2syslog_level()

static int logp2syslog_level | ( | unsigned int | level | ) |

static

References level, LOGL_ERROR, LOGL_FATAL, LOGL_INFO, and LOGL_NOTICE.

Referenced by _syslog_output().

## map_subsys()

static int map_subsys | ( | int | subsys | ) |

inline static

References DLGLOBAL, log_info::num_cat, log_info::num_cat_user, OSMO_ASSERT, osmo_log_info, subsys, and subsys_lib2index().

Referenced by log_check_level(), log_set_category_filter(), and osmo_vlogp().

## osmo_static_assert() [1/3]

osmo_static_assert | ( | _LOG_CTX_COUNT<= | ARRAY_SIZE((struct log_context *) NULL) ->ctx,
|  | enum_logging_ctx_items_fit_in_struct_log_context |
| ) |  |

## osmo_static_assert() [2/3]

osmo_static_assert | ( | _LOG_FLT_COUNT<=8 * | sizeof((struct log_target *) NULL) ->filter_map,
|  | enum_logging_filters_fit_in_log_target_filter_map |
| ) |  |

## osmo_static_assert() [3/3]

osmo_static_assert | ( | _LOG_FLT_COUNT<= | ARRAY_SIZE((struct log_target *) NULL) ->filter_data,
|  | enum_logging_filters_fit_in_log_target_filter_data |
| ) |  |

## osmo_vlogp()

void osmo_vlogp | ( | int | subsys,
|  | int | level,
|  | const char * | file,
|  | int | line,
|  | int | cont,
|  | const char * | format,
|  | va_list | ap
| ) |  |

vararg version of logging function

Parameters

  [in] | subsys | Logging sub-system
  [in] | level | Log level
  [in] | file | name of source code file
  [in] | cont | continuation (1) or new line (0)
  [in] | format | format string
  [in] | ap | vararg-list containing format string arguments

References _output(), log_target::entry, level, llist_for_each_entry, map_subsys(), osmo_log_target_list, log_target::raw_output, should_log_to_target(), and subsys.

Referenced by logp(), and logp2().

## should_log_to_target()

static bool should_log_to_target | ( | struct log_target * | tar,
|  | int | subsys,
|  | int | level
| ) |  |

inline static

References log_target::categories, log_category::enabled, log_info::filter_fn, log_target::filter_map, LOG_FLT_ALL, log_category::loglevel, log_target::loglevel, osmo_log_info, and subsys.

Referenced by log_check_level(), and osmo_vlogp().

## subsys_lib2index()

static int subsys_lib2index | ( | int | subsys | ) |

static

References log_info::num_cat_user, osmo_log_info, and subsys.

Referenced by map_subsys().

## Variable Documentation

## internal_cat

const struct log_info_cat internal_cat[OSMO_NUM_DLIB]

static

Referenced by log_init().

## level_colors

const struct value_string level_colors[]

static

Initial value:
= {
{ LOGL_DEBUG, "\033[1;34m" },
{ LOGL_INFO, "\033[1;32m" },
{ LOGL_NOTICE, "\033[1;33m" },
{ LOGL_ERROR, "\033[1;31m" },
{ LOGL_FATAL, "\033[1;31m" },
{ 0, NULL }
}

Referenced by level_color().

## log_context

struct log_context log_context

static

## loglevel_descriptions

const char* loglevel_descriptions[LOGLEVEL_DEFS+1]

static

Initial value:
= {
"Don't use. It doesn't log anything",
"Log debug messages and higher levels",
"Log informational messages and higher levels",
"Log noticeable messages and higher levels",
"Log error messages and higher levels",
"Log only fatal messages",
NULL,
}

descriptive string for each log level

Referenced by log_vty_command_description().

## loglevel_strs

const struct value_string loglevel_strs[LOGLEVEL_DEFS+1]

static

Initial value:
= {
{ 0, "EVERYTHING" },
{ LOGL_DEBUG, "DEBUG" },
{ LOGL_INFO, "INFO" },
{ LOGL_NOTICE, "NOTICE" },
{ LOGL_ERROR, "ERROR" },
{ LOGL_FATAL, "FATAL" },
{ 0, NULL },
}

Referenced by log_level_str(), log_parse_level(), and log_vty_command_string().

## osmo_log_info

struct log_info* osmo_log_info

Referenced by assert_loginfo(), color(), log_category_name(), log_fini(), log_init(), log_parse_category(), log_parse_category_mask(), log_target_create(), log_vty_command_description(), log_vty_command_string(), map_subsys(), should_log_to_target(), and subsys_lib2index().

## osmo_log_target_list

struct llist_head osmo_log_target_list

Referenced by log_add_target(), log_check_level(), log_fini(), log_target_find(), log_targets_reopen(), and osmo_vlogp().

## tall_log_ctx

void* tall_log_ctx = NULL

static

Referenced by log_fini(), log_init(), log_target_create(), log_vty_command_description(), and log_vty_command_string().

LOGL_FATAL
#define LOGL_FATAL
fatal, program aborted
Definition: logging.h:104
level
uint8_t level
logging level
Definition: gsmtap.h:8
LOGL_INFO
#define LOGL_INFO
general information
Definition: logging.h:101
LOGL_NOTICE
#define LOGL_NOTICE
abnormal/unexpected condition
Definition: logging.h:102
logp2
void logp2(int subsys, unsigned int level, const char *file, int line, int cont, const char *format,...) __attribute__((format(printf
logging function used by LOGP() macro
Definition: logging.c:555
log_check_level
int log_check_level(int subsys, unsigned int level)
Check whether a log entry will be generated.
Definition: logging.c:1135
LOGL_DEBUG
#define LOGL_DEBUG
different log levels
Definition: logging.h:100
LOGL_ERROR
#define LOGL_ERROR
error condition, requires user action
Definition: logging.h:103